import 'package:chhota_stocks_flutter/src/feature/discover/model/discover_model.dart';
import 'package:json_annotation/json_annotation.dart';


part 'more_details_model.g.dart';
@JsonSerializable()
class MoreDetailsModel{
  int? code;
  String? error;
  bool? status;
  String? errorMsg;
   Map<String,dynamic>? holdings;

  @JsonKey(name:"result")
  MoreDetailsResult? moreDetailsResult;
  MoreDetailsModel({this.code,this.error,this.status,this.moreDetailsResult,this.holdings});

  MoreDetailsModel.withError({required String errorMsg}):this.errorMsg=errorMsg;

  factory MoreDetailsModel.fromJson(Map<String, dynamic> json) => _$MoreDetailsModelFromJson(json);


}


@JsonSerializable()
class MoreDetailsResult{
  @JsonKey(name: "data")
  MoreDetailsData? moreDetailsData;

  String? errors;

  bool? success;

  MoreDetailsResult({this.moreDetailsData,this.errors,this.success});

  factory MoreDetailsResult.fromJson(Map<String, dynamic> json) => _$MoreDetailsResultFromJson(json);

}

@JsonSerializable()
class MoreDetailsData{
  @JsonKey(name: "_id")
  String? id;

  BenchMark? benchMark;

  List<Constituents>?     constituents;
  Flags? flags;

  Info? info;
  String? rationale;
  String? scid;

  List<Segments>? segments;
  Stats? stats;
  int? version;

  MoreDetailsData({this.id,this.benchMark,this.constituents,this.flags,this.info,this.rationale,this.scid,this.segments,this.stats,this.version});

  factory MoreDetailsData.fromJson(Map<String, dynamic> json) => _$MoreDetailsDataFromJson(json);



}

@JsonSerializable()
class Constituents{

  num? shares;
  String? stockName;
  String? ticker;
  num? weight;
  num? averagePrice;
  num? returns;



  bool isConstituentOf(List<String>? constituents){
     if(constituents==null||this.ticker==null){
       return false;
     }else{
       final data=constituents.where((element) => element==this.ticker).toList();


       return data!=null&&data.isNotEmpty;
     }


  }

  Constituents({this.shares,this.stockName,this.ticker,this.weight,this.averagePrice,this.returns});

  factory Constituents.fromJson(Map<String, dynamic> json) => _$ConstituentsFromJson(json);




}

@JsonSerializable()
class Segments{
   List<String>? constituents;

   String? label;
   Segments({this.constituents,this.label});

   factory Segments.fromJson(Map<String, dynamic> json) => _$SegmentsFromJson(json);

}

@JsonSerializable()
class Flags{

  bool? active;
  bool? blocked;
  bool? historicalData;

  bool? locked;
  String? preferredSipType;
  bool? private;
  bool? amoPending;
  bool? sip;
  String? sipType;

  Flags({this.active,this.blocked,this.historicalData,this.locked,this.preferredSipType,this.private,this.amoPending,this.sip,this.sipType});


  factory Flags.fromJson(Map<String, dynamic> json) => _$FlagsFromJson(json);



}





